<?php
/*
********************************************************
* @author Santos Montano B. (Lito Santos M.)
* @author_url 1: http://www.kanorika.com
* @author_url 2: http://codecanyon.net/user/kanorika
* @author_email: info@kanorika.com   
********************************************************
* Babbel - Collective Intelligence
* Copyright (c) 2018 Kanorika. All rights reserved.
********************************************************
*/
	$D->is_logged = $this->user->is_logged;
    
    if ($D->is_logged) require_once('_all-required-dashboard.php');
    else require_once('_all-required-home.php');
	
	$D->is_home = TRUE;
	
	/*************************************************************************/
	// needed before proceeding
	require_once('_all-required-language.php');
	
	/*************************************************************************/
	
	$this->load_langfile('global/global.php');
	$this->load_langfile('outside/home.php');

    /*************************************************************************/

    //all categories in an array
    $D->allCategories = $this->db2->fetch_all('SELECT idcategory, name, seo_url_cat FROM categories ORDER BY name ASC');

    /*************************************************************************/
    
    $D->thecategory = '';
    if ($this->param('thecategory')) $D->thecategory = $this->param('thecategory');
    
    $D->idcategory = isCategory($D->thecategory, $D->allCategories);
    
    if (!$D->idcategory) {
        $D->thecategory = '';
        $D->idcategory = 0;
    }
	
	/*************************************************************************/
    // Recents Articles 
    
    if ($D->idcategory == 0) {
    	$D->totalposts = $this->db2->fetch_field("SELECT count(idpost) FROM posts WHERE typepost='e_article'");
    } else {
    	$D->totalposts = $this->db2->fetch_field("SELECT count(idpost) FROM posts WHERE idcategory=".$D->idcategory." AND typepost='e_article'");
    }
    
	/**** Pagination ****/
    
	$D->recentsperpage = $C->RECENTS_PER_PAGE;
	$D->pageCurrent = 1;
	
	if ($this->param('p')) $D->pageCurrent = $this->param('p');
	
	$D->start = ($D->pageCurrent-1) * $D->recentsperpage;
	
	$D->totalPag = ceil($D->totalposts/$D->recentsperpage);
    if ($D->totalPag <= 0) $D->totalPag = 1;
	
	if ($D->totalPag<$D->pageCurrent) $this->redirect($C->SITE_URL);
	
	$D->pagVisibles = 2;
	
	if ($D->totalPag > (2 * $D->pagVisibles) + 1) {
	
		$D->firstPage = $D->pageCurrent - $D->pagVisibles;
		if ($D->firstPage < 1) $D->firstPage = 1;
		
		$D->lastPage = $D->firstPage + (2 * $D->pagVisibles);
		if ($D->lastPage > $D->totalPag) $D->lastPage = $D->totalPag;
		
		if ($D->lastPage - $D->firstPage < (2 * $D->pagVisibles) + 1) $D->firstPage = $D->lastPage - (2 * $D->pagVisibles);
		
	} else {
		
		$D->firstPage = 1;
		$D->lastPage = $D->totalPag;
	}
	
	/********************/    
	
    if ($D->idcategory == 0 && empty($D->thecategory)) {
    	$r = $this->db2->query("SELECT * FROM posts WHERE typepost='e_article' ORDER BY whendate DESC LIMIT ".$D->start.",".$D->recentsperpage);
    } else {
    	$r = $this->db2->query("SELECT * FROM posts WHERE idcategory=".$D->idcategory." AND typepost='e_article' ORDER BY whendate DESC LIMIT ".$D->start.",".$D->recentsperpage);
    }

	$D->numitems = $this->db2->num_rows();
	
	$D->htmlResult = '';
	
	while ($obj = $this->db2->fetch_object($r)) {
        
        $D->oneArticle = $obj;

        $D->oneArticle->post = stripslashes($obj->post);

        $D->seo_url_cat = getSeoURLCat($D->oneArticle->idcategory, $D->allCategories);
        
        $D->name_cat = stripslashes(getNameCat($D->oneArticle->idcategory, $D->allCategories));
    
		$D->htmlResult .= $this->load_template('__featured-one-article.php', FALSE);
		
	}
    unset($obj, $r);

	/*************************************************************************/
    
    $D->afeaturedsidebar = $C->ARTICLES_FEATURED_SIDEBAR;
    
    if ($D->idcategory == 0 && empty($D->thecategory)) {
    	$r = $this->db2->query("SELECT * FROM posts WHERE typepost='e_article' ORDER BY points DESC LIMIT 0,".$D->afeaturedsidebar);
    } else {
    	$r = $this->db2->query("SELECT * FROM posts WHERE idcategory=".$D->idcategory." AND typepost='e_article' ORDER BY points DESC LIMIT 0,".$D->afeaturedsidebar);
    }

	$D->htmlRecents = '';
	
	while ($obj = $this->db2->fetch_object($r)) {
        
        $D->oneArticle = $obj;

        $D->oneArticle->post = stripslashes($obj->post);

        $D->seo_url_cat = getSeoURLCat($D->oneArticle->idcategory, $D->allCategories);
    
		$D->htmlRecents .= $this->load_template('__sidebar_one-article.php', FALSE);
		
	}
    unset($obj, $r);
    
	/*************************************************************************/
    
    $D->commentssidebar = $C->COMMENTS_RECENTS_SIDEBAR;
    
    if ($D->idcategory == 0 && empty($D->thecategory)) {
    	$r = $this->db2->query("SELECT posts.*, avatar FROM posts, comments, users WHERE typeitem=1 AND comments.idpost=posts.idpost AND comments.iduser=users.iduser ORDER BY comments.whendate DESC LIMIT 0,".$D->commentssidebar);
    } else {
    	$r = $this->db2->query("SELECT posts.*, avatar FROM posts, comments, users WHERE idcategory=".$D->idcategory." AND typeitem=1 AND comments.idpost=posts.idpost AND comments.iduser=users.iduser ORDER BY comments.whendate DESC LIMIT 0,".$D->commentssidebar);
    }
    
    $D->num_comment = $this->db2->num_rows();

	$D->htmlRecentsComments = '';
	
    $count = 0;
    
    $D->without_separator = 0;
    
	while ($obj = $this->db2->fetch_object($r)) {
        
        $D->oneArticle = $obj;

        $D->oneArticle->post = stripslashes($obj->post);
        
        $D->oneArticle->avatar = empty($obj->avatar) ? 'default.png' : $obj->avatar;

        $D->seo_url_cat = getSeoURLCat($D->oneArticle->idcategory, $D->allCategories);
        
        $count = $count + 1;
        if ($count >= $D->num_comment) $D->without_separator = 1;
    
		$D->htmlRecentsComments .= $this->load_template('__sidebar_one-comment.php', FALSE);
		
	}
    unset($obj, $r);
    
	/*************************************************************************/

    $D->searchsidebar = $C->MOST_SEARCH_SIDEBAR;
    
    if ($D->idcategory == 0 && empty($D->thecategory)) {
    	$r = $this->db2->query("SELECT posts.* FROM posts, searchs WHERE typepost='e_article' AND searchs.iditem=posts.idpost AND posts.idpost=searchs.iditem ORDER BY searchs.numsearch DESC LIMIT 0,".$D->searchsidebar);
    } else {
    	$r = $this->db2->query("SELECT posts.* FROM posts, searchs WHERE idcategory=".$D->idcategory." AND typepost='e_article' AND searchs.iditem=posts.idpost AND posts.idpost=searchs.iditem ORDER BY searchs.numsearch DESC LIMIT 0,".$D->searchsidebar);
    }
    
    $D->num_results = $this->db2->num_rows();

	$D->htmlMostSearch = '';
	
    $count = 0;
    
    $D->without_separator = 0;
    
	while ($obj = $this->db2->fetch_object($r)) {
        
        $D->oneArticle = $obj;

        $D->oneArticle->post = stripslashes($obj->post);

        $D->seo_url_cat = getSeoURLCat($D->oneArticle->idcategory, $D->allCategories);
        
        $count = $count + 1;
        if ($count >= $D->num_results) $D->without_separator = 1;
    
		$D->htmlMostSearch .= $this->load_template('__sidebar_one-search.php', FALSE);
		
	}
    unset($obj, $r);
    
	/*************************************************************************/
    
    $D->topusersidebar = $C->TOP_USERS_SIDEBAR;
    
	$r = $this->db2->query("SELECT * FROM users WHERE active=1 ORDER BY total_points DESC LIMIT 0,".$D->topusersidebar);
    
    $D->num_results = $this->db2->num_rows();

	$D->htmlTopTen = '';
	
    $count = 0;
    
    $D->without_separator = 0;
    
	while ($obj = $this->db2->fetch_object($r)) {
        
        $D->oneUser = $obj;
        
        $D->oneUser->avatar = empty($obj->avatar) ? 'default.png' : $obj->avatar;
        
        $D->nameUser = (empty($obj->firstname) || empty($obj->lastname)) ? $obj->username:($obj->firstname.' '.$obj->lastname);
        
        $count = $count + 1;
        if ($count >= $D->num_results) $D->without_separator = 1;
    
		$D->htmlTopTen .= $this->load_template('__sidebar_one-user-top.php', FALSE);
		
	}
    unset($obj, $r);
    
	/*------------------------------------------------------------------------*/

    if (!empty($D->thecategory)) $D->ogURL = $C->SITE_URL.'articles/' . $D->thecategory . '/recents';
    else $D->ogURL = $C->SITE_URL.'articles/recents';
    
	/*------------------------------------------------------------------------*/
    
    $D->opc_catalogue = 2;

	$D->page_title	= stripslashes($C->SITE_TITLE).' - '.$this->lang('slogan_site');

	$this->load_template('articles-recents.php');
?>