<?php
/*
********************************************************
* @author Santos Montano B. (Lito Santos M.)
* @author_url 1: http://www.kanorika.com
* @author_url 2: http://codecanyon.net/user/kanorika
* @author_email: info@kanorika.com   
********************************************************
* Babbel - Collective Intelligence
* Copyright (c) 2018 Kanorika. All rights reserved.
********************************************************
*/
if (isset($_GET['error'])) { $this->redirect($C->SITE_URL); }

$callback_URL = $C->SITE_URL.'callback-fb';
$FB_Permissions = array('email');

// Include the autoloader provided in the SDK
require_once 'helpers/facebook/autoload.php';

// Include required libraries
use Facebook\Facebook;
use Facebook\Exceptions\FacebookResponseException;
use Facebook\Exceptions\FacebookSDKException;

$fb = new Facebook(array(
	'app_id' => $C->FB_APPID,
	'app_secret' => $C->FB_SECRET,
	'default_graph_version' => 'v2.2',
));

$helper = $fb->getRedirectLoginHelper();

try {
	if(isset($_SESSION['facebook_access_token'])){
		$accessToken = $_SESSION['facebook_access_token'];
	}else{
  		$accessToken = $helper->getAccessToken();
	}
} catch(FacebookResponseException $e) {
 	echo 'Graph returned an error: ' . $e->getMessage();
  	exit;
} catch(FacebookSDKException $e) {
	echo 'Facebook SDK returned an error: ' . $e->getMessage();
  	exit;
}

if(isset($accessToken)){
    
	if(isset($_SESSION['facebook_access_token'])){
		$fb->setDefaultAccessToken($_SESSION['facebook_access_token']);
	}else{
		
		$_SESSION['facebook_access_token'] = (string) $accessToken;
		
		$oAuth2Client = $fb->getOAuth2Client();
		
		$longLivedAccessToken = $oAuth2Client->getLongLivedAccessToken($_SESSION['facebook_access_token']);
		$_SESSION['facebook_access_token'] = (string) $longLivedAccessToken;

		$fb->setDefaultAccessToken($_SESSION['facebook_access_token']);
	}
    
	if(isset($_GET['code'])){
        $this->redirect('login');
	}
    
	try {
		$profileRequest = $fb->get('/me?fields=name,first_name,last_name,email,link,gender,locale,picture.width(500)');
		$fbUserProfile = $profileRequest->getGraphNode()->asArray();
	} catch(FacebookResponseException $e) {
		echo 'Graph returned an error: ' . $e->getMessage();
		session_destroy();
		$this->redirect('login');
		exit;
	} catch(FacebookSDKException $e) {
		echo 'Facebook SDK returned an error: ' . $e->getMessage();
		exit;
	}

	$fbUserData = array(
		'oauth_provider'=> 'facebook',
		'oauth_uid' => $fbUserProfile['id'],
		'first_name' => $fbUserProfile['first_name'],
		'last_name' => $fbUserProfile['last_name'],
        'displayname' => $fbUserProfile['name'],
		'email' => $fbUserProfile['email'],
		'gender' => $fbUserProfile['gender'],
		'locale' => $fbUserProfile['locale'],
		'picture' => $fbUserProfile['picture']['url'],
		'link' => $fbUserProfile['link'],
	);

    $fb_email = $this->db1->e($fbUserData['email']);
    
    $usersimple = $this->db1->fetch_field("SELECT iduser FROM users WHERE email='".$fbUserData['email']."' AND auth=''");
    if ($usersimple) {
        $D->msg_alert = 'The email that this facebook account is using is already registered';
        session_destroy();
    } else {
        
        $r = $this->db1->query("SELECT username FROM users WHERE email='".$fb_email."' AND auth='facebook'");
        if (!($obj = $db2->fetch_object($r))) {
            $code = uniqueCode(11, 1, 'users', 'code');
            $fb_pass = getCode(10,1);
            
            $salt = md5(uniqid(rand(), true));
            $hash = hash('sha512', $salt.$fb_pass);
            $ip	= $this->db1->escape( ip2long($_SERVER['REMOTE_ADDR']) );
            
            $fb_id = $fbUserData['oauth_uid'];
            $fb_first_name = $this->db1->e($fbUserData['first_name']);
            $fb_last_name = $this->db1->e($fbUserData['last_name']);
            $fb_gender = $fbUserData['gender'];
            $fb_username = $fbUserData['displayname'];
            $fb_username = str_replace(' ','',$fb_username);
            $fb_username = str_replace('.','',$fb_username);
            
            //if the username does not work, use your email
            if (!validateUsername($fb_username)) {
                $newUser = explode('@',$fb_email);
                $fb_username = str_replace('.','',$newUser[0]);
                $fb_username = str_replace('-','',$fb_username);
                $lenun = strlen($fb_username);
                if (strlen($fb_username)<6) $fb_username = $fb_username . getCode(6-$lenun,1);
            }
            
            $numu = $this->db1->fetch_field("SELECT count(iduser) FROM users WHERE username='".$fb_username."'");
            if ($numu != 0) $fb_username = $fb_username.''.($numu + 1);
            
            $fb_username = $this->db1->e($fb_username);				
            
            $gender = 0;
            if ($fb_gender == 'male') $gender = 1;
            if ($fb_gender == 'female') $gender = 2;
            
            $finalphoto = '';
            if (!empty($fbUserData['picture'])) {
                $image_tmp = $fbUserData['picture'];
                $pos = strpos($image_tmp, '?');
                if (FALSE !== $pos) $image_tmp = substr($image_tmp, 0, $pos);

                $ext = explode(".",$image_tmp);
                $finalphoto = $code.'.'.$ext[count($ext)-1];
                $res_avatar = copyImageFromUrl($fbUserData['picture'], '../'.$C->FOLDER_AVATAR.'origins/', $finalphoto);
                if (!$res_avatar) $finalphoto = '';
                else {
                    $root = '../'.$C->FOLDER_AVATAR;
                    if (file_exists($root.'origins/'.$finalphoto)) {
                        require_once('classes/class_SmartImage.php');
                        $thumbnail = new SmartImage($root.'origins/'.$finalphoto, true);
                        $thumbnail->myresize($C->widthAvatar0, 'width');
                        $thumbnail->saveImage($root.$finalphoto);
                        $thumbnail->close();
    
                        $thumbnail = new SmartImage($root.'origins/'.$finalphoto, true);
                        $thumbnail->mycrop($C->widthAvatar1, $C->heightAvatar1);
                        $thumbnail->saveImage($root.'min1/'.$finalphoto);				
                        $thumbnail->close();
    
                        $thumbnail = new SmartImage($root.'origins/'.$finalphoto, true);
                        $thumbnail->mycrop($C->widthAvatar2, $C->heightAvatar2);
                        $thumbnail->saveImage($root.'min2/'.$finalphoto);
                        $thumbnail->close();
    
                        $thumbnail = new SmartImage($root.'origins/'.$finalphoto, true);
                        $thumbnail->mycrop($C->widthAvatar3, $C->heightAvatar3);
                        $thumbnail->saveImage($root.'min3/'.$finalphoto);
                        $thumbnail->close();
    
                        $thumbnail = new SmartImage($root.'origins/'.$finalphoto, true);
                        $thumbnail->mycrop($C->widthAvatar4, $C->heightAvatar4);
                        $thumbnail->saveImage($root.'min4/'.$finalphoto);
                        $thumbnail->close();
                    }
                }
            }
            
            $r = $this->db1->query("INSERT INTO users SET code='".$code."', password='" . $hash . "', salt='" . $salt . "', auth='facebook', username='".$fb_username."', auth_id='".$fb_id."', firstname='".$fb_first_name."', lastname='".$fb_last_name."', email='".$fb_email."', registerdate='" . time() . "', ipregister='" . $ip . "', gender=".$gender.", avatar='".$finalphoto."', facebook='".$fbUserData['link']."'");
        } else {
            $fb_username = $obj->username;
        }
        $this->user->loginSocial($fb_username, 'facebook');
        $this->redirect($C->SITE_URL);
    }

    
} else {
    
	$D->FB_loginURL = htmlspecialchars($helper->getLoginUrl($callback_URL, $FB_Permissions));

}