<?php
/*
********************************************************
* @author Santos Montano B. (Lito Santos M.)
* @author_url 1: http://www.kanorika.com
* @author_url 2: http://codecanyon.net/user/kanorika
* @author_email: info@kanorika.com   
********************************************************
* Babbel - Collective Intelligence
* Copyright (c) 2018 Kanorika. All rights reserved.
********************************************************
*/
    $allCategories = $this->db2->fetch_all('SELECT idcategory, name, seo_url_cat FROM categories ORDER BY name ASC');

    $insitemap = $this->param('insitemap');
    
    $insitemap = is_string($insitemap) ? $insitemap : null;
    
    // Optimize sitemap request
    $insitemap = ltrim($insitemap, '-');
    $moreMap = strtolower($insitemap);

    // Create time value
    $timeUTC = date('Y-m-d') . 'T' . date('H:i:s') . '+00:00';
    
    // Set header for XML
    header('Content-Type: application/xml; charset=UTF-8');
    
    echo '<?xml version="1.0" encoding="UTF-8"?>';
    echo "\n";
    echo '<?xml-stylesheet type="text/xsl" href="' . $C->SITE_URL . 'themes/' . $C->THEME . '/others/sitemap.xsl"?>';
    echo "\n\n";
    echo '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ' .
        'xmlns:image="http://www.google.com/schemas/sitemap-image/1.1" ' .
        'xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 ' .
        'http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" ' .
        'xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
    echo "\n";
    // Prepare sitemap links (init)
    $sitemapLinks = array();

    // Refer XML sitemap
    $referXML = true;

    // Start process on HTTP request demand
    if ($insitemap == null) {
        // Home page
        $sitemapLinks[] = array('url' => '', 'pri' => 100, 'frq' => 'hourly', 'xml' => false);

        // Categories
        $sitemapLinks[] = array('url' => 'categories', 'pri' => 95, 'frq' => 'monthly');

        // all articles
        $sitemapLinks[] = array('url' => 'articles', 'pri' => 90, 'frq' => 'hourly');

        // featured
        $sitemapLinks[] = array('url' => 'featured', 'pri' => 90, 'frq' => 'hourly');

        // searchs
        $sitemapLinks[] = array('url' => 'search', 'pri' => 80, 'frq' => 'hourly');

        // all users
        $sitemapLinks[] = array('url' => 'users', 'pri' => 70, 'frq' => 'daily');

        // users top
        $sitemapLinks[] = array('url' => 'users-top', 'pri' => 70, 'frq' => 'daily');

    } elseif ($moreMap == 'featured') {
        
        $featured = $this->db2->query("SELECT * FROM posts WHERE typepost='e_article' ORDER BY points DESC LIMIT 50");
        
        while ($obj = $this->db2->fetch_object($featured)) {
            
            $oneArticle = $obj;
    
            $seo_url_cat = getSeoURLCat($oneArticle->idcategory, $allCategories);
        
            $sitemapLinks[] = array(
                'url' => 'articles/'.$seo_url_cat.'/'.$oneArticle->code.'/'.$oneArticle->seo_url,
                'frq' => 'monthly',
                'pri' => 30,
                'xml' => false
            );
        
        }


    } elseif ($moreMap == 'articles') {
        
    	$total_articles = $this->db2->fetch_field("SELECT count(idpost) FROM posts WHERE typepost='e_article'");

        $numPages = ceil($total_articles / 50);
        $widthNumbers = strlen("{$rvCount}");
        for ($i = 1; $i <= $numPages; $i++) {
            $sitemapLinks[] = array(
                'url' => "articles-page-" . str_pad($i, $widthNumbers, '0', STR_PAD_LEFT),
                'pri' => 90,
                'frq' => 'hourly'
            );
        }

    } elseif (preg_match('/^articles\-page\-(?P<page>[0-9]+)?/i', $moreMap, $matches)) {
        
        $referXML = false;
        
        $page = intval($matches['page']);
        
        $offset = ($page - 1) * 50;
        
        $articles = $this->db2->query("SELECT * FROM posts WHERE typepost='e_article' ORDER BY idpost DESC LIMIT ".$offset.",50");
        
        while ($obj = $this->db2->fetch_object($articles)) {
            
            $oneArticle = $obj;
    
            $seo_url_cat = getSeoURLCat($oneArticle->idcategory, $allCategories);
        
            $sitemapLinks[] = array(
                'url' => 'articles/'.$seo_url_cat.'/'.$oneArticle->code.'/'.$oneArticle->seo_url,
                'frq' => 'monthly',
                'pri' => 20
            );
        
        }

    } elseif ($moreMap == 'users-top') {
        
        $referXML = false;
        
        $topusers = $this->db2->query("SELECT username FROM users WHERE active=1 ORDER BY total_points DESC LIMIT 0,".$C->TOP_USERS_SIDEBAR);
        
        while ($obj = $this->db2->fetch_object($topusers)) {
            
            $oneUser = $obj;
    
            $sitemapLinks[] = array(
                'url' => $oneUser->username,
                'frq' => 'monthly',
                'pri' => 30
            );
        
        }

    } elseif ($moreMap == 'users') {
        
    	$total_users = $this->db2->fetch_field("SELECT count(iduser) FROM users WHERE active=1");

        $numPages = ceil($total_users / 50);
        $widthNumbers = strlen("{$rvCount}");
        for ($i = 1; $i <= $numPages; $i++) {
            $sitemapLinks[] = array(
                'url' => "users-page-" . str_pad($i, $widthNumbers, '0', STR_PAD_LEFT),
                'pri' => 90,
                'frq' => 'hourly'
            );
        }

    } elseif (preg_match('/^users\-page\-(?P<page>[0-9]+)?/i', $moreMap, $matches)) {
        
        $referXML = false;
        
        $page = intval($matches['page']);
        
        $offset = ($page - 1) * 50;
        
        $users = $this->db2->query("SELECT username FROM users WHERE active=1 ORDER BY iduser DESC LIMIT ".$offset.",50");
        
        while ($obj = $this->db2->fetch_object($users)) {
            
            $oneUser = $obj;

            $sitemapLinks[] = array(
                'url' => $oneUser->username,
                'frq' => 'monthly',
                'pri' => 30
            );
        
        }
    } elseif ($moreMap == 'search') {
        
        $referXML = false;
        
        $searchs = $this->db2->query("SELECT posts.* FROM posts, searchs WHERE typepost='e_article' AND searchs.iditem=posts.idpost AND posts.idpost=searchs.iditem ORDER BY searchs.numsearch DESC LIMIT 50");
        
        while ($obj = $this->db2->fetch_object($searchs)) {
            
            $oneArticle = $obj;
    
            $seo_url_cat = getSeoURLCat($oneArticle->idcategory, $allCategories);
        
            $sitemapLinks[] = array(
                'url' => 'articles/'.$seo_url_cat.'/'.$oneArticle->code.'/'.$oneArticle->seo_url,
                'frq' => 'monthly',
                'pri' => 20
            );
        
        }

    } elseif ($moreMap == 'categories') {
        
        $referXML = false;
        
        $categories = $this->db2->query("SELECT seo_url_cat FROM categories");
        
        while ($obj = $this->db2->fetch_object($categories)) {
            
            $oneCategorie = $obj;
    
            $seo_url_cat = 'articles/'.$oneCategorie->seo_url_cat;
        
            $sitemapLinks[] = array(
                'url' => $seo_url_cat,
                'frq' => 'monthly',
                'pri' => 10
            );
        
        }

    }

    // Print sitemap links
    if (count($sitemapLinks) > 0) {
        foreach ($sitemapLinks as $sLink) {
            // Prepare sitemap row
            list($url, $xml, $mod, $frq, $pri) = array(null, null, null, null, null);
            if (is_array($sLink)) {
                if (isset($sLink['url'])) {
                    $url = $sLink['url'];
                }
                $xml = isset($sLink['xml']) ? $sLink['xml'] : $referXML;
                $mod = isset($sLink['mod']) ? $sLink['mod'] : $timeUTC;
                $frq = isset($sLink['frq']) ? $sLink['frq'] : 'weekly';
                $pri = isset($sLink['pri']) ? ($sLink['pri'] / 100) : (rand(30, 60) / 100);
            } else {
                $url = $sLink;
                $xml = $referXML;
                $mod = $timeUTC;
                $frq = 'weekly';
                $pri = rand(30, 60) / 100;
            }
            // Print sitemap row
            if (is_string($url)) {
                echo "    <url>\n";
                echo "        <loc>" . $C->SITE_URL . ($xml ? "sitemap-{$url}.xml" : $url) . "</loc>\n";
                echo "        <lastmod>{$mod}</lastmod>\n";
                echo "        <changefreq>{$frq}</changefreq>\n";
                echo "        <priority>{$pri}</priority>\n";
                echo "    </url>\n";
            }
        }
    }
    echo "</urlset>\n";
?>