<?php
/*
********************************************************
* @author Santos Montano B. (Lito Santos M.)
* @author_url 1: http://www.kanorika.com
* @author_url 2: http://codecanyon.net/user/kanorika
* @author_email: info@kanorika.com   
********************************************************
* Babbel - Collective Intelligence
* Copyright (c) 2018 Kanorika. All rights reserved.
********************************************************
*/

/** 
 * Main functions that are used in the application.
 */

	function __autoload($class_name)
	{
		global $C;
		require_once( $C->INCPATH.'classes/class_'.$class_name.'.php' );
	}
		
	function validateUrl($url)
	{
		if (!preg_match('/^(http|https):\/\/((([a-z0-9.-]+\.)+[a-z]{2,4})|([0-9\.]{1,4}){4})(\/([a-zA-Z?-?0-9-_\?\:%\.\?\!\=\+\&\/\#\~\;\,\@]+)?)?$/', $url))
			return FALSE;
		else return TRUE;
	}
	
	//function that checks if a URL is or is not "http"
	function fitsUrl($url) 
	{
		
		if( ! preg_match('/^(ftp|http|https):\/\//', $url) ) {
			$url = 'http://'.$url;
		}
	
		if( !validateUrl($url) ) return FALSE;
		
		return $url;
	}
	
	// function that returns the code of a YouTube video
	function getCodeYoutube($url, $lencodyt)
	{
		if( preg_match('/^http(s)?\:\/\/(www\.|de\.)?youtu\.be\/([a-z0-9-\_]{3,})/i', $url, $resultado) ) {
			$codeyt = $resultado[3];
			if (strlen($codeyt)!=$lencodyt) return FALSE;
			else return $codeyt;
		}
		if( preg_match('/^http(s)?\:\/\/(www\.|de\.)?youtube\.com\/watch\?(feature\=player\_embedded&)?v\=([a-z0-9-\_]{3,})/i', $url, $resultado) ) {
			$codeyt = $resultado[4];
			if (strlen($codeyt)!=$lencodyt) return FALSE;
			else return $codeyt;
		}
		return FALSE;
	}
	
	function emailValid($e)
	{
		return preg_match('/^[a-zA-Z0-9._%-]+@([a-zA-Z0-9.-]+\.)+[a-zA-Z]{2,4}$/u', $e);
	}
	
	
	// Function that checks if a code is already registered in a table
	function verifyCode($code, $table, $field)
	{			
		$mibdx2 = $GLOBALS["db2"];
		
		// check whether the code is being used
		$rx2 = $mibdx2->query("SELECT ".$field." FROM ".$table." WHERE ".$field."='".$code."' LIMIT 1");
		$numusers = $mibdx2->num_rows($rx2);

		if ($numusers==0) return FALSE;
		else return TRUE;			
	}
	
	//*************************************************************************
	// Function that returns a random string.
	// $numcharacters: number of letters returned string will.
	// $withrepeated: if 0 returns a string with no letters repeated. 
	// $withrepeated: if 1 returns a string with repeated letters.
	function getCode($numcharacters,$withrepeated)
	{
		$code = '';
		$characters = "0123456789abcdfghjkmnpqrstvwxyzBCDFGHJKMNPQRSTVWXYZ";
		$i = 0;
		while ($i < $numcharacters) {
			$char = substr($characters, mt_rand(0, strlen($characters)-1), 1);	
			if ($withrepeated == 1) {
				$code .= $char;
				$i += 1;			
			} else {
				if(!strstr($code,$char)) {
					$code .= $char;
					$i += 1;
				}
			}
		}
		return $code;
	}
	//*************************************************************************

	// Function that seeks a 11 digit code that is not registered in a table.
	function uniqueCode($numcharacters, $withrepeated, $table, $field)
	{
		$code = getCode($numcharacters, $withrepeated);
		while (verifyCode($code, $table, $field)) {	
			$code = getCode(11, 1);
		}
		return $code;
	}
	//*************************************************************************	
	
	function analyzeMessage($txtmsg) {
		global $C;
		// Parse any @mentions or links
		
		$analyzedText = preg_replace(array('/(?i)\b((?:https?:\/\/|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:\'".,<>?«»“”‘’]))/', '/(^|[^a-z0-9_])@([a-z0-9_]+)/i', '/(^|[^a-z0-9_])#(\w+)/u'), array('<a href="$1" target="_blank" rel="nofollow" class="linkblue">$1</a>', '$1<span class="linkblue3"><a href="'.$C->SITE_URL.'$2">@$2</a></span>', '$1<span class="linkblue3"><a href="'.$C->SITE_URL.'hashtag/t%%%$2">#$2</a></span>'), ($txtmsg));
		
		
		// Define smiles
		$emoticons = array(
			':-)'	=> 'regular.png',
			':)'	=> 'regular.png',
			':-D'	=> 'teeth.png',
			':d'	=> 'teeth.png',
			':D'	=> 'teeth.png',
			':-O'	=> 'omg.png',
			':o'	=> 'omg.png',
			':O'	=> 'omg.png',
			':-P'	=> 'tongue.png',
			':p'	=> 'tongue.png',
			':P'	=> 'tongue.png',
			';-)'	=> 'wink.png',
			';)'	=> 'wink.png',
			':(('	=> 'cry.png',
			':-('	=> 'sad.png',
			':('	=> 'sad.png',
			':-S'	=> 'confused.png',
			':s'	=> 'confused.png',
			':S'	=> 'confused.png',
			':-|'	=> 'what.png',
			':|'	=> 'what.png',
			':-$'	=> 'red.png',
			':$'	=> 'red.png',
			'(H)'	=> 'shades.png',
			'(h)'	=> 'shades.png',
			':-@'	=> 'angry.png',
			':@'	=> 'angry.png',
			'(A)'	=> 'angel.png',
			'(a)'	=> 'angel.png',
			'(6)'	=> 'devil.png',
			':-#'	=> 'dumb.png',
			'8o|'	=> 'growl.png',
			'8-|'	=> 'nerd.png',
			'^o)'	=> 'sarcastic.png',
			':-*'	=> 'secret.png',
			'+o('	=> 'sick.png',
			':^)'	=> 'noknow.png',
			'*-)'	=> 'pensive.png',
			'8-)'	=> 'eyesrolled.png',
			'|-)'	=> 'sleepy.png',
			'(C)'	=> 'coffee.png',
			'(c)'	=> 'coffee.png',
			'(Y)'	=> 'thumbs_up.png',
			'(y)'	=> 'thumbs_up.png',
			'(n)'	=> 'thumbs_down.png',
			'(N)'	=> 'thumbs_down.png',
			'(B)'	=> 'beer_mug.png',
			'(b)'	=> 'beer_mug.png',
			'(D)'	=> 'martini.png',
			'(d)'	=> 'martini.png',
			'(X)'	=> 'girl.png',
			'(x)'	=> 'girl.png',
			'(Z)'	=> 'guy.png',
			'(z)'	=> 'guy.png',
			'({)'	=> 'guy_hug.png',
			'(})'	=> 'girl_hug.png',
			':-['	=> 'bat.png',
			':['	=> 'bat.png',
			'(^)'	=> 'cake.png',
			'(L)'	=> 'heart.png',
			'(l)'	=> 'heart.png',
			'(U)'	=> 'broken_heart.png',
			'(u)'	=> 'broken_heart.png',
			'(K)'	=> 'kiss.png',
			'(k)'	=> 'kiss.png',
			'(G)'	=> 'present.png',
			'(g)'	=> 'present.png',
			'(F)'	=> 'rose.png',
			'(f)'	=> 'rose.png',
			'(W)'	=> 'wilted_rose.png',
			'(w)'	=> 'wilted_rose.png',
			'(p)'	=> 'camera.png',
			'(P)'	=> 'camera.png',
			'(~)'	=> 'film.png',
			'(@)'	=> 'cat.png',
			'(dg)'	=> 'dog.png',
			'(T)'	=> 'phone.png',
			'(t)'	=> 'phone.png',
			'(I)'	=> 'lightbulb.png',
			'(i)'	=> 'lightbulb.png',
			'(8)'	=> 'note.png',
			'(S)'	=> 'moon.png',
			'(*)'	=> 'star.png',
			'(e)'	=> 'envelope.png',
			'(E)'	=> 'envelope.png',
			'(o)'	=> 'clock.png',
			'(O)'	=> 'clock.png',
			'(sn)'	=> 'scargot.png',
			'(pl)'	=> 'dish.png',
			'(||)'	=> 'bowl.png',
			'(pi)'	=> 'pizza.png',
			'(so)'	=> 'ball.png',
			'(au)'	=> 'car.png',
			'(um)'	=> 'umb.png',
			'(ip)'	=> 'isla.png',
			'(co)'	=> 'pc.png',
			'(mp)'	=> 'cel.png',
			'(mo)'	=> 'money.png',
		);
		
		foreach($emoticons as $emoticons => $img) {
			$analyzedText = str_replace($emoticons, '<img src="'.$C->SITE_URL.'themes/default/imgs/emotics/'.$img.'" height="16" width="16" />', $analyzedText);
		}
		
		$analyzedText = str_replace('%%%', ':', $analyzedText);

		return str_replace(PHP_EOL, '<br/>',stripslashes($analyzedText));
	}
	
	//*************************************************************************
	
	function str_cut($str, $mx)
	{
		return mb_strlen($str)>$mx ? mb_substr($str, 0, $mx-1).'...' : $str;
	}
	
	//*************************************************************************
	
	function getCaptcha()
	{
		global $C;
		$Valor1 = rand(1,9);
		$Valor2 = rand(1,9);
		$_SESSION['captchasum'] = $Valor1 + $Valor2 ;
		$C->ctcha1 = $Valor1;
		$C->ctcha2 = $Valor2;
	}
	
	//*************************************************************************
	
	function clearnl($msg)
	{
		return preg_replace("/(\r?\n){2,}/", "\n\n", $msg);
	}
	
	//*************************************************************************
	
 	function send_mail( $from, $to, $subject, $body ) {
		$headers = '';
		$headers .= "From: $from\n";
		$headers .= "Return-Path: $from\n";
		$headers .= "MIME-Version: 1.0\n";
		$headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";
		$headers .= "Date: " . date('r', time()) . "\n";
		
	
		mail( $to, $subject , $body, $headers );
	}
	
	
	function send_mail_phpmailer($target, $subject, $message)
	{
		require("class.phpmailer.php");
		global $C;
		$mymail = new PHPMailer();
		$mybody = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>Email from '.$C->FromName.'</title>
		</head><body>';
		$mybody .= $message;
		$mybody .= '</body></html>';
		
		$mymail->From = $C->From;
		$mymail->FromName = $C->FromName;
		$mymail->Host = $C->Host;
		$mymail->Port = $C->Port;
		$mymail->Mailer = 'smtp';
		$mymail->AddAddress($target);
		$mymail->Subject = $subject;
		$mymail->Body = $mybody;
		$mymail->SMTPAuth = "true";
		$mymail->Username = $C->UsernameMail;
		$mymail->Password = $C->PasswordMail;
		
		$mymail->IsHTML(true);    
		
		if(!$mymail->Send()) return FALSE;
		else return TRUE;
	}

	function genSpaceEmoticons($divspace) {
		global $C;
		
		// Define smiles
		$emoticons = array(
			':-)'	=> 'regular.png',
			':-D'	=> 'teeth.png',
			':-O'	=> 'omg.png',
			':-P'	=> 'tongue.png',
			';-)'	=> 'wink.png',
			':(('	=> 'cry.png',
			':-('	=> 'sad.png',
			':-S'	=> 'confused.png',
			':-|'	=> 'what.png',
			':-$'	=> 'red.png',
			'(H)'	=> 'shades.png',
			':-@'	=> 'angry.png',
			'(A)'	=> 'angel.png',
			'(6)'	=> 'devil.png',
			':-#'	=> 'dumb.png',
			'8o|'	=> 'growl.png',
			'8-|'	=> 'nerd.png',
			'^o)'	=> 'sarcastic.png',
			':-*'	=> 'secret.png',
			'+o('	=> 'sick.png',
			':^)'	=> 'noknow.png',
			'*-)'	=> 'pensive.png',
			'8-)'	=> 'eyesrolled.png',
			'|-)'	=> 'sleepy.png',
			'(C)'	=> 'coffee.png',
			'(Y)'	=> 'thumbs_up.png',
			'(N)'	=> 'thumbs_down.png',
			'(B)'	=> 'beer_mug.png',
			'(D)'	=> 'martini.png',
			'(X)'	=> 'girl.png',
			'(Z)'	=> 'guy.png',
			'({)'	=> 'guy_hug.png',
			'(})'	=> 'girl_hug.png',
			':-['	=> 'bat.png',
			'(^)'	=> 'cake.png',
			'(L)'	=> 'heart.png',
			'(U)'	=> 'broken_heart.png',
			'(K)'	=> 'kiss.png',
			'(G)'	=> 'present.png',
			'(F)'	=> 'rose.png',
			'(W)'	=> 'wilted_rose.png',
			'(P)'	=> 'camera.png',
			'(~)'	=> 'film.png',
			'(@)'	=> 'cat.png',
			'(dg)'	=> 'dog.png',
			'(T)'	=> 'phone.png',
			'(I)'	=> 'lightbulb.png',
			'(8)'	=> 'note.png',
			'(S)'	=> 'moon.png',
			'(*)'	=> 'star.png',
			'(E)'	=> 'envelope.png',
			'(O)'	=> 'clock.png',
			'(sn)'	=> 'scargot.png',
			'(pl)'	=> 'dish.png',
			'(||)'	=> 'bowl.png',
			'(pi)'	=> 'pizza.png',
			'(so)'	=> 'ball.png',
			'(au)'	=> 'car.png',
			'(um)'	=> 'umb.png',
			'(ip)'	=> 'isla.png',
			'(co)'	=> 'pc.png',
			'(mp)'	=> 'cel.png',
			'(mo)'	=> 'money.png',
		);

		$txtEmoticons = '';
		foreach($emoticons as $emoticons => $img) {
			$txtEmoticons .= '<span class="onesmile"><img onclick="insertEmoticon(\''.$divspace.'\', \''.$emoticons.'\');" class="hand" title="'.$emoticons.'" src="'.$C->SITE_URL.'themes/default/imgs/emotics/'.$img.'" height="16" width="16" /></span>';
		}
		return $txtEmoticons;
	}
	
	function analyzeMessageChat($txtmsg) {
		global $C;
		// Parse any @mentions or links
		
		$analyzedText = preg_replace(array('/(?i)\b((?:https?:\/\/|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:\'".,<>?«»“”‘’]))/', '/(^|[^a-z0-9_])@([a-z0-9_]+)/i', '/(^|[^a-z0-9_])#(\w+)/u'), array('<a href="$1" target="_blank" rel="nofollow" class="linkblue">$1</a>', '$1<span class="linkblue3"><a href="'.$C->SITE_URL.'$2">@$2</a></span>', '$1<span class="linkblue3"><a href="'.$C->SITE_URL.'hashtag/t%%%$2">#$2</a></span>'), ($txtmsg));
		
		
		// Define smiles
		$emoticons = array(
			':-)'	=> 'regular.png',
			':)'	=> 'regular.png',
			':-D'	=> 'teeth.png',
			':d'	=> 'teeth.png',
			':D'	=> 'teeth.png',
			':-O'	=> 'omg.png',
			':o'	=> 'omg.png',
			':O'	=> 'omg.png',
			':-P'	=> 'tongue.png',
			':p'	=> 'tongue.png',
			':P'	=> 'tongue.png',
			';-)'	=> 'wink.png',
			';)'	=> 'wink.png',
			':(('	=> 'cry.png',
			':-('	=> 'sad.png',
			':('	=> 'sad.png',
			':-S'	=> 'confused.png',
			':s'	=> 'confused.png',
			':S'	=> 'confused.png',
			':-|'	=> 'what.png',
			':|'	=> 'what.png',
			':-$'	=> 'red.png',
			':$'	=> 'red.png',
			'(H)'	=> 'shades.png',
			'(h)'	=> 'shades.png',
			':-@'	=> 'angry.png',
			':@'	=> 'angry.png',
			'(A)'	=> 'angel.png',
			'(a)'	=> 'angel.png',
			'(6)'	=> 'devil.png',
			':-#'	=> 'dumb.png',
			'8o|'	=> 'growl.png',
			'8-|'	=> 'nerd.png',
			'^o)'	=> 'sarcastic.png',
			':-*'	=> 'secret.png',
			'+o('	=> 'sick.png',
			':^)'	=> 'noknow.png',
			'*-)'	=> 'pensive.png',
			'8-)'	=> 'eyesrolled.png',
			'|-)'	=> 'sleepy.png',
			'(C)'	=> 'coffee.png',
			'(c)'	=> 'coffee.png',
			'(Y)'	=> 'thumbs_up.png',
			'(y)'	=> 'thumbs_up.png',
			'(n)'	=> 'thumbs_down.png',
			'(N)'	=> 'thumbs_down.png',
			'(B)'	=> 'beer_mug.png',
			'(b)'	=> 'beer_mug.png',
			'(D)'	=> 'martini.png',
			'(d)'	=> 'martini.png',
			'(X)'	=> 'girl.png',
			'(x)'	=> 'girl.png',
			'(Z)'	=> 'guy.png',
			'(z)'	=> 'guy.png',
			'({)'	=> 'guy_hug.png',
			'(})'	=> 'girl_hug.png',
			':-['	=> 'bat.png',
			':['	=> 'bat.png',
			'(^)'	=> 'cake.png',
			'(L)'	=> 'heart.png',
			'(l)'	=> 'heart.png',
			'(U)'	=> 'broken_heart.png',
			'(u)'	=> 'broken_heart.png',
			'(K)'	=> 'kiss.png',
			'(k)'	=> 'kiss.png',
			'(G)'	=> 'present.png',
			'(g)'	=> 'present.png',
			'(F)'	=> 'rose.png',
			'(f)'	=> 'rose.png',
			'(W)'	=> 'wilted_rose.png',
			'(w)'	=> 'wilted_rose.png',
			'(p)'	=> 'camera.png',
			'(P)'	=> 'camera.png',
			'(~)'	=> 'film.png',
			'(@)'	=> 'cat.png',
			'(dg)'	=> 'dog.png',
			'(T)'	=> 'phone.png',
			'(t)'	=> 'phone.png',
			'(I)'	=> 'lightbulb.png',
			'(i)'	=> 'lightbulb.png',
			'(8)'	=> 'note.png',
			'(S)'	=> 'moon.png',
			'(*)'	=> 'star.png',
			'(e)'	=> 'envelope.png',
			'(E)'	=> 'envelope.png',
			'(o)'	=> 'clock.png',
			'(O)'	=> 'clock.png',
			'(sn)'	=> 'scargot.png',
			'(pl)'	=> 'dish.png',
			'(||)'	=> 'bowl.png',
			'(pi)'	=> 'pizza.png',
			'(so)'	=> 'ball.png',
			'(au)'	=> 'car.png',
			'(um)'	=> 'umb.png',
			'(ip)'	=> 'isla.png',
			'(co)'	=> 'pc.png',
			'(mp)'	=> 'cel.png',
			'(mo)'	=> 'money.png',
		);
		
		if ($C->CHAT_WITH_EMOTICONS) {
			foreach($emoticons as $emoticons => $img) {
				$analyzedText = str_replace($emoticons, '<img src="'.$C->SITE_URL.'themes/default/imgs/emotics/'.$img.'" height="16" width="16" />', $analyzedText);
			}
		}
		
		$analyzedText = str_replace('%%%', ':', $analyzedText);

		return stripslashes($analyzedText);
	}
	
	function validateUsername($username) { 
		if (ereg("^[A-Za-z0-9][A-Za-z0-9_]{5,14}$", $username)) return true; 
		else return false; 
	}
    
    function sanitizeString($stringToClean) {
        $charsEspecials = array(
            '?' => 'S', '?' => 's', 'Ð' => 'Dj','?' => 'Z', '?' => 'z', 'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A', 'Ä' => 'A',
            'Å' => 'A', 'Æ' => 'A', 'Ç' => 'C', 'È' => 'E', 'É' => 'E', 'Ê' => 'E', 'Ë' => 'E', 'Ì' => 'I', 'Í' => 'I', 'Î' => 'I',
            'Ï' => 'I', 'Ñ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O', 'Õ' => 'O', 'Ö' => 'O', 'Ø' => 'O', 'Ù' => 'U', 'Ú' => 'U',
            'Û' => 'U', 'Ü' => 'U', 'Ý' => 'Y', 'Þ' => 'B', 'ß' => 'Ss','à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'a',
            'å' => 'a', 'æ' => 'a', 'ç' => 'c', 'è' => 'e', 'é' => 'e', 'ê' => 'e', 'ë' => 'e', 'ì' => 'i', 'í' => 'i', 'î' => 'i',
            'ï' => 'i', 'ð' => 'o', 'ñ' => 'n', 'ò' => 'o', 'ó' => 'o', 'ô' => 'o', 'õ' => 'o', 'ö' => 'o', 'ø' => 'o', 'ù' => 'u',
            'ú' => 'u', 'û' => 'u', 'ý' => 'y', 'ý' => 'y', 'þ' => 'b', 'ÿ' => 'y', 'ƒ' => 'f', ',' => '',  '.' => '',  ':' => '',
            ';' => '',  '_' => '',  '<' => '',  '>' => '',  '\\'=> '',  'ª' => '',  'º' => '',  '!' => '',  '|' => '',  '"' => '',
            '@' => '',  '·' => '',  '#' => '',  '$' => '',  '~' => '',  '%' => '',  '€' => '',  '&' => '',  '¬' => '',  '/' => '',
            '(' => '',  ')' => '',  '=' => '',  '?' => '',  '\''=> '',  '¿' => '',  '¡' => '',  '`' => '',  '+' => '',  '´' => '',
            'ç' => '',  '^' => '',  '*' => '',  '¨' => '',  'Ç' => '',  '[' => '',  ']' => '',  '{' => '',  '}' => '',  '? '=> '-',
            
            // Latin symbols
            '©' => '(c)',
            // Greek
            'Α' => 'A', 'Β' => 'B', 'Γ' => 'G', 'Δ' => 'D', 'Ε' => 'E', 'Ζ' => 'Z', 'Η' => 'H', 'Θ' => '8',
            'Ι' => 'I', 'Κ' => 'K', 'Λ' => 'L', 'Μ' => 'M', 'Ν' => 'N', 'Ξ' => '3', 'Ο' => 'O', 'Π' => 'P',
            'Ρ' => 'R', 'Σ' => 'S', 'Τ' => 'T', 'Υ' => 'Y', 'Φ' => 'F', 'Χ' => 'X', 'Ψ' => 'PS', 'Ω' => 'W',
            'Ά' => 'A', 'Έ' => 'E', 'Ί' => 'I', 'Ό' => 'O', 'Ύ' => 'Y', 'Ή' => 'H', 'Ώ' => 'W', 'Ϊ' => 'I',
            'Ϋ' => 'Y',
            'α' => 'a', 'β' => 'b', 'γ' => 'g', 'δ' => 'd', 'ε' => 'e', 'ζ' => 'z', 'η' => 'h', 'θ' => '8',
            'ι' => 'i', 'κ' => 'k', 'λ' => 'l', 'μ' => 'm', 'ν' => 'n', 'ξ' => '3', 'ο' => 'o', 'π' => 'p',
            'ρ' => 'r', 'σ' => 's', 'τ' => 't', 'υ' => 'y', 'φ' => 'f', 'χ' => 'x', 'ψ' => 'ps', 'ω' => 'w',
            'ά' => 'a', 'έ' => 'e', 'ί' => 'i', 'ό' => 'o', 'ύ' => 'y', 'ή' => 'h', 'ώ' => 'w', 'ς' => 's',
            'ϊ' => 'i', 'ΰ' => 'y', 'ϋ' => 'y', 'ΐ' => 'i',
            // Turkish
            'Ş' => 'S', 'İ' => 'I', 'Ç' => 'C', 'Ü' => 'U', 'Ö' => 'O', 'Ğ' => 'G',
            'ş' => 's', 'ı' => 'i', 'ç' => 'c', 'ü' => 'u', 'ö' => 'o', 'ğ' => 'g',
            // Russian
            'А' => 'A', 'Б' => 'B', 'В' => 'V', 'Г' => 'G', 'Д' => 'D', 'Е' => 'E', 'Ё' => 'Yo', 'Ж' => 'Zh',
            'З' => 'Z', 'И' => 'I', 'Й' => 'J', 'К' => 'K', 'Л' => 'L', 'М' => 'M', 'Н' => 'N', 'О' => 'O',
            'П' => 'P', 'Р' => 'R', 'С' => 'S', 'Т' => 'T', 'У' => 'U', 'Ф' => 'F', 'Х' => 'H', 'Ц' => 'C',
            'Ч' => 'Ch', 'Ш' => 'Sh', 'Щ' => 'Sh', 'Ъ' => '', 'Ы' => 'Y', 'Ь' => '', 'Э' => 'E', 'Ю' => 'Yu',
            'Я' => 'Ya',
            'а' => 'a', 'б' => 'b', 'в' => 'v', 'г' => 'g', 'д' => 'd', 'е' => 'e', 'ё' => 'yo', 'ж' => 'zh',
            'з' => 'z', 'и' => 'i', 'й' => 'j', 'к' => 'k', 'л' => 'l', 'м' => 'm', 'н' => 'n', 'о' => 'o',
            'п' => 'p', 'р' => 'r', 'с' => 's', 'т' => 't', 'у' => 'u', 'ф' => 'f', 'х' => 'h', 'ц' => 'c',
            'ч' => 'ch', 'ш' => 'sh', 'щ' => 'sh', 'ъ' => '', 'ы' => 'y', 'ь' => '', 'э' => 'e', 'ю' => 'yu',
            'я' => 'ya',
            // Ukrainian
            'Є' => 'Ye', 'І' => 'I', 'Ї' => 'Yi', 'Ґ' => 'G',
            'є' => 'ye', 'і' => 'i', 'ї' => 'yi', 'ґ' => 'g',
            // Czech
            'Č' => 'C', 'Ď' => 'D', 'Ě' => 'E', 'Ň' => 'N', 'Ř' => 'R', 'Š' => 'S', 'Ť' => 'T', 'Ů' => 'U',
            'Ž' => 'Z',
            'č' => 'c', 'ď' => 'd', 'ě' => 'e', 'ň' => 'n', 'ř' => 'r', 'š' => 's', 'ť' => 't', 'ů' => 'u',
            'ž' => 'z',
            // Polish
            'Ą' => 'A', 'Ć' => 'C', 'Ę' => 'e', 'Ł' => 'L', 'Ń' => 'N', 'Ó' => 'o', 'Ś' => 'S', 'Ź' => 'Z',
            'Ż' => 'Z',
            'ą' => 'a', 'ć' => 'c', 'ę' => 'e', 'ł' => 'l', 'ń' => 'n', 'ó' => 'o', 'ś' => 's', 'ź' => 'z',
            'ż' => 'z',
            // Latvian
            'Ā' => 'A', 'Č' => 'C', 'Ē' => 'E', 'Ģ' => 'G', 'Ī' => 'i', 'Ķ' => 'k', 'Ļ' => 'L', 'Ņ' => 'N',
            'Š' => 'S', 'Ū' => 'u', 'Ž' => 'Z',
            'ā' => 'a', 'č' => 'c', 'ē' => 'e', 'ģ' => 'g', 'ī' => 'i', 'ķ' => 'k', 'ļ' => 'l', 'ņ' => 'n',
            'š' => 's', 'ū' => 'u', 'ž' => 'z',

        );
        $stringToClean = str_replace('&', '-and-', $stringToClean);
        $stringToClean = str_replace('.', '', $stringToClean);
        $stringToClean = strtolower(strtr($stringToClean, $charsEspecials));
        $stringToClean = str_replace(' ', '-', $stringToClean);
        $stringToClean = str_replace('--', '-', $stringToClean);
        $stringToClean = str_replace('--', '-', $stringToClean);
        $stringToClean = preg_replace('/[^\w\d_ -]/si', '', $stringToClean);
        return trim($stringToClean);
    }
    
	function decodeSlug($text) {
		$text	= str_ireplace(":"," ", $text);	
		$text	= str_ireplace("+"," ", $text);	
		$text	= str_ireplace("-"," ", $text);	
		$text	= str_ireplace("/"," - ", $text);	
		$text	= str_ireplace("%20"," ", $text);	
		$text	= urldecode($text);	
		return $text;
	}
    

    function getSeoURL($thetable, $thefield, $idtable, $theurlseo, $thenumc) {
		$mydb2 = $GLOBALS["db2"];

        if ($thenumc == 0) $thecad = $theurlseo;
        else $thecad = $theurlseo.'-'.$thenumc;

        $numc = $mydb2->fetch_field("SELECT count(".$idtable.") FROM ".$thetable." WHERE ".$thefield."='".$thecad."'");
        if ($numc != 0) {
            $thenumc = $thenumc + $numc;
            return getSeoURL($thetable, $thefield, $idtable, $theurlseo, $thenumc);
        } else {
            if ($thenumc == 0) return $theurlseo;
            return $theurlseo.'-'.$thenumc;
        }
    }
    
    function getSeoURLCat($idcat, $arrayCats) {
        foreach($arrayCats as $oneC) {
            if ($idcat == $oneC->idcategory) {
                return $oneC->seo_url_cat;
            }
        }
        return FALSE;
    }

    function getNameCat($idcat, $arrayCats) {
        foreach($arrayCats as $oneC) {
            if ($idcat == $oneC->idcategory) {
                return $oneC->name;
            }
        }
        return FALSE;
    }

    function isCategory($seoURLCat, $arrayCats) {
        foreach($arrayCats as $oneC) {
            if ($seoURLCat == $oneC->seo_url_cat) {
                return $oneC->idcategory;
            }
        }
        return FALSE;
    }
    
    function filterBadWords($message) {
        
        global $C;
        
        $string_badwords = trim($C->BAD_WORDS_FILTERS);
        
        if (!empty($string_badwords)) {
            
            $badwords = explode(',', $string_badwords);
            
            foreach ($badwords as $badtxt) {
    
                $badtxt = trim($badtxt);
                $length = strlen($badtxt);
                $filter = substr($badtxt, 0, 1) . str_repeat("*", $length - 2) . substr($badtxt, $length - 1, 1);
                
                $search = "$badtxt";
                $message = preg_replace("'$search'i","<i>$filter</i>",$message);          
              
            }
        }
        
        return $message;   
    }

    function myCopy($source, $dest) {
        $res = @copy($source, $dest);
        if ($res) {
            chmod($dest, 0777);
            return TRUE;
        }
        
        if( function_exists('curl_init') && preg_match('/^(http|https|ftp)\:\/\//u', $source) ) {
            global $C;
            $dst = fopen($dest, 'w');
            if( ! $dst ) {
                return FALSE;
            }
            $ch = curl_init();
            curl_setopt_array($ch, array(
                CURLOPT_FILE => $dst,
                CURLOPT_HEADER => FALSE,
                CURLOPT_URL => $source,
                CURLOPT_CONNECTTIMEOUT => 3,
                CURLOPT_TIMEOUT => 5,
                CURLOPT_MAXREDIRS => 5,
                CURLOPT_REFERER => $C->SITE_URL,
                CURLOPT_USERAGENT => isset($_SERVER['HTTP_USER_AGENT']) ? trim($_SERVER['HTTP_USER_AGENT']) : 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.1) Gecko/2008070208 Firefox/3.0.1',
            ));
            @curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            $res = curl_exec($ch);
            fclose($dst);
            if (!$res) {
                curl_close($ch);
                return FALSE;
            }
            if (curl_errno($ch)) {
                curl_close($ch);
                return FALSE;
            }
            curl_close($ch);
            chmod($dest, 0777);
            return TRUE;
        }
        return FALSE;
    }
    
    function copyImageFromUrl($url_source, $folder_target, $name_target) {
        global $C;
        if ( preg_match('/^(http|https|ftp)\:\/\//u', $url_source) ) {
            $tmp = $folder_target.$name_target;
            $res = myCopy($url_source, $tmp);
            return $name_target;
        }
        return FALSE;
    }

?>